//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------

#define SC_USE_USER_DEFINED_VS_MAIN

#include <std.glsl>
#include <std_vs.glsl>
#include <std_fs.glsl>

#ifdef SKIN_SAMPLE
uniform sampler2D mainTexture;
uniform vec2 sampleCenter;
#else // SKIN_BLEND
uniform sampler2D leftSample;
uniform sampler2D rightSample;
#endif


#ifdef VERTEX_SHADER

void main(void) {
    sc_Vertex_t v = sc_LoadVertexAttributes();
#ifdef SKIN_SAMPLE
    v.texture0 = (v.texture0 + sampleCenter) * 0.5 + 0.5;
#endif
    sc_ProcessVertex(v);
}

#endif // VERTEX_SHADER


#ifdef FRAGMENT_SHADER

void main(void) {
#ifdef SKIN_SAMPLE
    vec3 color = texture2D(mainTexture, varTex0).rgb;
#else // SKIN_BLEND
    vec3 color0 = texture2D(leftSample, varTex0).rgb;
    vec3 color1 = texture2D(rightSample, varTex0).rgb;
    float w = 1.0 - varTex0.x;
    vec3 color = mix(color0, color1, w);
#endif
    gl_FragColor = vec4(color, 1.0);
}

#endif // FRAGMENT SHADER
